package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.Date;

import com.google.gson.annotations.SerializedName;




@ApiModel(description = "")
public class ChangesCommand   {
  
  @SerializedName("change")
  private String change = null;
  
  @SerializedName("date")
  private Date date = null;
  
  @SerializedName("user")
  private String user = null;
  
  @SerializedName("client")
  private String client = null;
  
  @SerializedName("status")
  private String status = null;
  
  @SerializedName("type")
  private String type = null;
  
  @SerializedName("path")
  private String _path = null;
  
  @SerializedName("description")
  private String description = null;
  

  
  /**
   * The changelist ID
   **/
  @ApiModelProperty(value = "The changelist ID")
  public String getChange() {
    return change;
  }
  public void setChange(String change) {
    this.change = change;
  }

  
  /**
   * Last modification time of the changelist
   **/
  @ApiModelProperty(value = "Last modification time of the changelist")
  public Date getDate() {
    return date;
  }
  public void setDate(Date date) {
    this.date = date;
  }

  
  /**
   * The owner of the changelist
   **/
  @ApiModelProperty(value = "The owner of the changelist")
  public String getUser() {
    return user;
  }
  public void setUser(String user) {
    this.user = user;
  }

  
  /**
   * Name of current client workspace.
   **/
  @ApiModelProperty(value = "Name of current client workspace.")
  public String getClient() {
    return client;
  }
  public void setClient(String client) {
    this.client = client;
  }

  
  /**
   * `pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.
   **/
  @ApiModelProperty(value = "`pending`, `shelved`, `submitted`, or `new`.\nNot editable by the user.\n\nThe status is `new` when the changelist is created, `pending` when it has been created but has not yet been submitted to the depot, `shelved` when its contents are shelved, and `submitted` when its contents have been stored in the depot.")
  public String getStatus() {
    return status;
  }
  public void setStatus(String status) {
    this.status = status;
  }

  
  /**
   * Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.
   **/
  @ApiModelProperty(value = "Type of change: `restricted` or `public`.\n\nThe Type: field can be used to hide the change or its description from users.\nA shelved or committed change (as denoted in the Status: field) that is restricted is accessible only to users who own the change or have list permission to at least one file in the change.\n\nPublic changes are displayed without restrictions.\n\nBy default, changelists are public.\nA Perforce superuser can set the default changelist type (for changelists created after the configurable is set) by setting the defaultChangeType configurable.")
  public String getType() {
    return type;
  }
  public void setType(String type) {
    this.type = type;
  }

  
  /**
   * Depot paths affected by this changelist
   **/
  @ApiModelProperty(value = "Depot paths affected by this changelist")
  public String getPath() {
    return _path;
  }
  public void setPath(String _path) {
    this._path = _path;
  }

  
  /**
   * Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.
   **/
  @ApiModelProperty(value = "Textual description of changelist.\n\nIf you do not have access to a restricted changelist, the description is replaced with a \"no permission\" message.")
  public String getDescription() {
    return description;
  }
  public void setDescription(String description) {
    this.description = description;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ChangesCommand changesCommand = (ChangesCommand) o;
    return Objects.equals(this.change, changesCommand.change) &&
        Objects.equals(this.date, changesCommand.date) &&
        Objects.equals(this.user, changesCommand.user) &&
        Objects.equals(this.client, changesCommand.client) &&
        Objects.equals(this.status, changesCommand.status) &&
        Objects.equals(this.type, changesCommand.type) &&
        Objects.equals(this._path, changesCommand._path) &&
        Objects.equals(this.description, changesCommand.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(change, date, user, client, status, type, _path, description);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ChangesCommand {\n");
    
    sb.append("    change: ").append(toIndentedString(change)).append("\n");
    sb.append("    date: ").append(toIndentedString(date)).append("\n");
    sb.append("    user: ").append(toIndentedString(user)).append("\n");
    sb.append("    client: ").append(toIndentedString(client)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    _path: ").append(toIndentedString(_path)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
