package com.perforce.hwsclient.models;

import java.util.Objects;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import com.google.gson.annotations.SerializedName;




/**
 * Identification of servers the Helix Web Services instance can connect to.
 **/
@ApiModel(description = "Identification of servers the Helix Web Services instance can connect to.")
public class P4dConfigId   {
  
  @SerializedName("id")
  private String id = null;
  
  @SerializedName("name")
  private String name = null;
  
  @SerializedName("description")
  private String description = null;
  

  
  /**
   * A simple string identifier (alphanumeric characters only, please)
   **/
  @ApiModelProperty(value = "A simple string identifier (alphanumeric characters only, please)")
  public String getId() {
    return id;
  }
  public void setId(String id) {
    this.id = id;
  }

  
  /**
   * A display string, not guaranteed to be unique
   **/
  @ApiModelProperty(value = "A display string, not guaranteed to be unique")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  
  /**
   * A simple textual description, for potential selection by clients.
   **/
  @ApiModelProperty(value = "A simple textual description, for potential selection by clients.")
  public String getDescription() {
    return description;
  }
  public void setDescription(String description) {
    this.description = description;
  }

  

  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    P4dConfigId p4dConfigId = (P4dConfigId) o;
    return Objects.equals(this.id, p4dConfigId.id) &&
        Objects.equals(this.name, p4dConfigId.name) &&
        Objects.equals(this.description, p4dConfigId.description);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, description);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class P4dConfigId {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}
